require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_KERNEL_H)) {
    eval 'sub _LINUX_KERNEL_H () {1;}' unless defined(&_LINUX_KERNEL_H);
    eval 'sub __ALIGN_KERNEL {
        my($x, $a) = @_;
	    eval q( &__ALIGN_KERNEL_MASK($x, ( &typeof($x))($a) - 1));
    }' unless defined(&__ALIGN_KERNEL);
    eval 'sub __ALIGN_KERNEL_MASK {
        my($x, $mask) = @_;
	    eval q(((($x) + ($mask)) & ~($mask)));
    }' unless defined(&__ALIGN_KERNEL_MASK);
    eval 'sub SI_LOAD_SHIFT () {16;}' unless defined(&SI_LOAD_SHIFT);
    if(defined(&__CHECKER__)) {
	eval 'sub BUILD_BUG_ON_NOT_POWER_OF_2 {
	    my($n) = @_;
    	    eval q();
	}' unless defined(&BUILD_BUG_ON_NOT_POWER_OF_2);
	eval 'sub BUILD_BUG_ON_ZERO {
	    my($e) = @_;
    	    eval q((0));
	}' unless defined(&BUILD_BUG_ON_ZERO);
	eval 'sub BUILD_BUG_ON_NULL {
	    my($e) = @_;
    	    eval q((( &void*)0));
	}' unless defined(&BUILD_BUG_ON_NULL);
	eval 'sub BUILD_BUG_ON {
	    my($condition) = @_;
    	    eval q();
	}' unless defined(&BUILD_BUG_ON);
    } else {
	eval 'sub BUILD_BUG_ON_NOT_POWER_OF_2 {
	    my($n) = @_;
    	    eval q( &BUILD_BUG_ON(($n) == 0|| ((($n) & (($n) - 1)) != 0)));
	}' unless defined(&BUILD_BUG_ON_NOT_POWER_OF_2);
	eval 'sub BUILD_BUG_ON_ZERO {
	    my($e) = @_;
    	    eval q(($sizeof{\'struct struct\' { \'int\':-!!($e); }}));
	}' unless defined(&BUILD_BUG_ON_ZERO);
	eval 'sub BUILD_BUG_ON_NULL {
	    my($e) = @_;
    	    eval q((( &void *)$sizeof{\'struct struct\' { \'int\':-!!($e); }}));
	}' unless defined(&BUILD_BUG_ON_NULL);
	unless(defined(&__OPTIMIZE__)) {
	    eval 'sub BUILD_BUG_ON {
	        my($condition) = @_;
    		eval q((( &void)$sizeof{\'char\'[1- 2!!($condition)]}));
	    }' unless defined(&BUILD_BUG_ON);
	} else {
	    eval 'sub BUILD_BUG_ON {
	        my($condition) = @_;
    		eval q( &do { (( &void)$sizeof{\'char\'[1- 2!!($condition)]});  &if ($condition)  &__build_bug_on_failed = 1; }  &while(0));
	    }' unless defined(&BUILD_BUG_ON);
	}
    }
    eval 'sub __FUNCTION__ () {( &__func__);}' unless defined(&__FUNCTION__);
    if(defined(&CONFIG_NUMA)) {
	eval 'sub NUMA_BUILD () {1;}' unless defined(&NUMA_BUILD);
    } else {
	eval 'sub NUMA_BUILD () {0;}' unless defined(&NUMA_BUILD);
    }
    if(defined(&CONFIG_COMPACTION)) {
	eval 'sub COMPACTION_BUILD () {1;}' unless defined(&COMPACTION_BUILD);
    } else {
	eval 'sub COMPACTION_BUILD () {0;}' unless defined(&COMPACTION_BUILD);
    }
    if(defined(&CONFIG_FTRACE_MCOUNT_RECORD)) {
	eval 'sub REBUILD_DUE_TO_FTRACE_MCOUNT_RECORD () {1;}' unless defined(&REBUILD_DUE_TO_FTRACE_MCOUNT_RECORD);
    }
}
1;
